// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/11/12
// Update  : 2009/11/12
// Description : フォームのパスワード入力支援
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var passwordTextExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'pwdExt', // 対象とするクラス
		readonly : true, // パスワード表示中の入力許可（true：禁止/false:許可）
		icon : {
			path : 'images/', // アイコン画像の配置ディレクトリ（ルート・絶対・相対/jsを使用するhtmlファイルからの位置）
			open : 'icon_lock_close.gif', // 表示時のアイコン画像名
			close : 'icon_lock_open.gif', // 非表示時のアイコン画像名
			width : '16', // アイコン画像の幅
			height : '16', // アイコン画像の高さ
			alt : 'パスワードを表示する', // アイコン画像のalt
			style : 'cursor:pointer; padding-left:3px;' // アイコン画像に適用するスタイル
		}
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	initialize : function() {
		var ipts = passwordTextExtension.getTargetElements('input', passwordTextExtension.conf.targetClass);
		for ( var i = 0, len = ipts.length; i < len; i++ ) {
			if ( ipts[i].type.toLowerCase() == 'password' ) {
				passwordTextExtension.set(ipts[i]);
			}
		}
	},
	//-----------------------------------------
	// パスワード表示用リンクとイベントのセット
	//-----------------------------------------
	set : function(element) {
		if ( element.id && element.id != '' ) {
			var img = document.createElement('img');
			img.src = passwordTextExtension.conf.icon.path + passwordTextExtension.conf.icon.close;
			img.alt = passwordTextExtension.conf.icon.alt;
			img.width = passwordTextExtension.conf.icon.width;
			img.height = passwordTextExtension.conf.icon.height;
			img.style.cssText = passwordTextExtension.conf.icon.style;
			img.targetId = element.id;
			img.state = false;
			passwordTextExtension.addEvent(img, 'click', passwordTextExtension.disp);
			passwordTextExtension.insertAfter(img, element);
		}
	},
	//-----------------------------------------
	// パスワード表示操作
	//-----------------------------------------
	disp : function() {
		var input = document.getElementById(this.targetId);
		var parent = input.parentNode;
		if ( input ) {
			if ( this.state == false ) {
				// 表示
				var text = document.createElement('input');
				text.setAttribute('type', 'text');
				text.setAttribute('name', input.getAttribute('name'));
				text.setAttribute('id',  input.getAttribute('id'));
				text.className = input.className;
				if ( input.style.cssText && input.style.cssText != '' ) {
					pass.style.cssText = input.style.cssText;
				}
				if ( input.maxLength && input.maxLength != -1 && input.maxLength != '' ) {
					text.maxLength = input.maxLength;
				}
				if ( input.size && input.size != '' ) {
					text.size = input.size;
				}
				if ( input.accessKey && input.accessKey != '' ) {
					text.accessKey = input.accessKey;
				}
				text.value = input.value;
				text.readOnly = passwordTextExtension.conf.readonly;
				this.origin = input;
				parent.replaceChild(text, input);
				this.src = passwordTextExtension.conf.icon.path + passwordTextExtension.conf.icon.open;
				this.state = true;
			} else {
				// 非表示
				this.origin.value = input.value;
				parent.replaceChild(this.origin, input);
				this.src = passwordTextExtension.conf.icon.path + passwordTextExtension.conf.icon.close;
				this.state = false;
			}
		}
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	insertAfter : function(node, referenceNode) {
		var parent = referenceNode.parentNode;
		parent.insertBefore(node, referenceNode.nextSibling);
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		for ( var i = 0, len = targetElements.length; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements[elements.length] = targetElements[i];
			}
		}
		return elements;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
passwordTextExtension.addEvent(window, 'load', passwordTextExtension.initialize);